# -*-makefile-*-

AFM=$(CID).afm

PFBSRC = $(wildcard *.pfb)
AFMSRC = $(PFBSRC:.pfb=.afm)
SUBR = $(PFBSRC:.pfb=.subr)
CHAR = $(PFBSRC:.pfb=.char)

.SUFFIXES: .pfb .pfa .c1 .c2 .csv .csv2 .scsv .scsv2 .char .subr

all: $(CID) $(AFM)

.pfb.pfa:
	pfb2pfa $<

.pfa.c1:
	sed -e '/^%!/,/eexec/d' -e '/^000000000/,/cleartomark/d' < $< > $@

.c1.c2:
	rm -f t.in t.out
	cp $< t.in
	gs -DNODISPLAY -q -dBATCH decrypt.ps
	mv t.out $@
	rm -f t.in

.c2.csv:
	 $(TOOLSDIR)/conv < $< | sed -e '/^$$/d' > $@

.csv.csv2:
	ruby $(TOOLSDIR)/offset.rb $< > $@

.csv2.char:
	ruby $(TOOLSDIR)/csv2bin.rb $< > $@

.c2.scsv:
	 $(TOOLSDIR)/convsubr < $< > $@

.scsv.scsv2:
	ruby $(TOOLSDIR)/offset.rb $< > $@

.scsv2.subr:
	ruby $(TOOLSDIR)/csv2bin.rb $< > $@

# ǽΥե /.notdef 饯ղä
$(SRCBASE)m06.csv: $(SRCBASE)m06.c2
	$(TOOLSDIR)/conv < $< | sed -e '/^$$/d' > $@
	/bin/sh $(TOOLSDIR)/add_notdef.sh $@

$(SRCBASE).cidmap: $(TOOLSDIR)/makecidmap.rb $(TOOLSDIR)/sizes.rb $(SUBR) $(CHAR) $(PFBSRC:.pfb=.csv2)
	ruby -I $(TOOLSDIR)/ $(TOOLSDIR)/makecidmap.rb $@ $(PFBSRC:.pfb=.csv2)

$(SRCBASE).subrmap: $(TOOLSDIR)/makesubrmap.rb $(TOOLSDIR)/sizes.rb $(SUBR) $(CHAR) $(PFBSRC:.pfb=.scsv2)
	ruby -I $(TOOLSDIR)/ $(TOOLSDIR)/makesubrmap.rb $@ $(PFBSRC:.pfb=.scsv2)

$(SRCBASE).resource: $(SRCBASE).cidmap $(SRCBASE).subrmap $(SUBR) $(CHAR)
	cat $(SRCBASE).cidmap $(SRCBASE).subrmap $(SUBR) $(CHAR) > $@

$(SRCBASE).head: $(TOOLSDIR)/makeheader.rb $(TOOLSDIR)/sizes.rb $(SRCBASE).resource
	ruby -I $(TOOLSDIR)/ $(TOOLSDIR)/makeheader.rb $(CID) > $@

$(SRCBASE).foot: $(TOOLSDIR)/makefooter.rb
	ruby $(TOOLSDIR)/makefooter.rb > $@

$(CID): $(SRCBASE).head $(SRCBASE).resource $(SRCBASE).foot
	cat $^ > $@

$(AFM): $(TOOLSDIR)/makeafm.rb $(AFMSRC)
	ruby -I $(TOOLSDIR)/ $(TOOLSDIR)/makeafm.rb $(CID) $(AFMSRC) > $@

clean:
	rm -f $(CID) $(AFM) $(CHAR) $(SUBR) \
		$(wildcard *.pfa) \
		$(wildcard *.c1)  $(wildcard *.c2) \
		$(wildcard *.csv) $(wildcard *.csv2) \
		$(wildcard *.scsv) $(wildcard *.scsv2) \
		$(wildcard $(SRCBASE).*)
